/*
	Vip System 2.0 [ReAPI]
	edition by pUzzlik for http://www.neugomon.ru
*/

// reapi vip system version
#define VIP_SYSTEM_VERSION "2.3 free"

#if AMXX_VERSION_NUM < 183
	#include <colorchat>
	#define client_disconnected client_disconnect
#endif

#if !defined MAX_NAME_LENGTH
	#define MAX_NAME_LENGTH 32
#endif
#define is_valid_player(%0) (0 < %0 < 33)

/**
 * Returns whether a player is vip.
 *
 * @param id		Player index.
 * @return			True if it is, false otherwise.
 */
native get_flag_access_def(const id);

/**
 * Returns whether a player is second flag.
 *
 * @param id		Player index.
 * @return			True if it is, false otherwise.
 */
native get_flag_access(const id);

/**
 * Returns number of rounds.
 *
 * @return		Round count.
 */
native get_round_num();

/**
 * @return			True if it is, false otherwise.
 */
native get_block_maps()

/**
 * Returns whether to give a bonus to spawn.
 *
 * @param id		Player index.
 * @return			True if it is, false otherwise.
 */
native core_is_bonus_spawn(const id);

/**
 * Returns whether it is possible to use the VIP menu.
 *
 * @param id		Player index.
 * @return			True if it is, false otherwise.
 */
native core_is_allow_use(const id);

/**
 * Registers a custom item which will be added to the vip shop.
 *
 * @param name			Caption to display on the menu.
 * @param cost			Cost to display on the menu.
 */
native vip_register_items(const name[], cost);

/**
* Compatible with Admin Loader from neugomon (https://www.neugomon.ru/threads/486/)
* Returns admin expired.
*
* @param id		Player index.
*/
native admin_expired(id);

/**
 * Description:		check if the scenario has been won/lost
 *
 * @param round		Round number.
 */
forward vip_core_restart_round(round);

/**
 * Player spawn
 *
 * @param id		Player index.
 */
forward vip_core_player_spawn(const id);