#include <amxmodx>
#include <amxmisc>
#include <reapi>
#include <vip_system>

#pragma semicolon 1
enum _:cvars { FLAG_DEF, FLAG, VIPMENU, BLOCKBONUS };
new pCvar[cvars], g_Flags[cvars], g_iMenuRnd, g_iBonusRnd;

enum _:fwd { FWD_SPAWN, FWD_RESTART };
new g_fwdFunction[fwd];
new g_iRound;

new HookChain:Player_Spawn;

public plugin_natives() {
	register_library("Vip System 2.3");
	register_native("get_flag_access_def", "native_flag_access_def", 1);
	register_native("get_flag_access", "native_flag_access", 1);
	register_native("get_round_num", "native_round_num", 1);
	register_native("get_block_maps", "native_block_maps", 1);
	register_native("core_is_bonus_spawn", "native_bonus_spawn", 1);
	register_native("core_is_allow_use", "native_allow_use", 1);
}

public native_flag_access_def(id){
	if(is_user_connected(id) && get_user_flags(id) & g_Flags[FLAG_DEF]) return true;
	return false;
}

public native_flag_access(id){
	if(is_user_connected(id) && get_user_flags(id) & g_Flags[FLAG]) return true;
	return false;
}

public native_round_num()
	return g_iRound;
	
public native_block_maps() {
	new szDisabledFile[64];
	get_configsdir(szDisabledFile, charsmax(szDisabledFile));
	formatex(szDisabledFile, charsmax(szDisabledFile), "%s/vip_disabled_maps.cfg", szDisabledFile);

	if(file_exists(szDisabledFile)) {
		new iLineNum, szData[64], iTextLen;
		new szMapName[64]; rh_get_mapname(szMapName, charsmax(szMapName));

		while(read_file(szDisabledFile, iLineNum, szData, charsmax(szData), iTextLen)) {
			if(containi(szMapName, szData) != -1) return true;
			iLineNum++;
		}
	}
	return false;
}
	
public native_bonus_spawn(id) {
	if(!is_user_alive(id)) return false;
	if(get_block_maps()) return false;
	if(!get_flag_access_def(id)) return false;
	return true;
}
	
public native_allow_use(id) {
	if(!is_user_alive(id)) {
		client_print_color(id, -2, "%L %L", LANG_SERVER, "CHAT_TAG", LANG_SERVER, "VIP_ALIVE");
		return false;
	}
	if(get_block_maps()) {
		client_print_color(id, -2, "%L %L", LANG_SERVER, "CHAT_TAG", LANG_SERVER, "BLOCK_MAPS");
		return false;
	}
	if(!get_flag_access_def(id)) {
		client_print_color(id, -2, "%L %L", LANG_SERVER, "CHAT_TAG", LANG_SERVER, "ONLY_VIP");
		return false;
	}
	if(g_iMenuRnd > g_iRound) {
		client_print_color(id, -2, "%L %L", LANG_SERVER, "CHAT_TAG", LANG_SERVER, "WARMUP_ROUND");
		return false;
	}
	return true;
}

public plugin_init() {
	register_plugin("[ReVIP] System Core", VIP_SYSTEM_VERSION, "pUzzlik");

	//	flag access def. t
	pCvar[FLAG_DEF] = register_cvar("access_flag_vip","");
	//	flag access (def. g)
	pCvar[FLAG] = register_cvar("other_access_flag","");
	//	with round displayed vip menu
	pCvar[VIPMENU] = register_cvar("display_menu_rnd","");
	//	with round enable forward spawn player
	pCvar[BLOCKBONUS] = register_cvar("spawn_player_block","");
	register_dictionary("vip_system.txt");

	g_fwdFunction[FWD_RESTART] = CreateMultiForward("vip_core_restart_round", ET_IGNORE, FP_CELL);
	g_fwdFunction[FWD_SPAWN] = CreateMultiForward("vip_core_player_spawn", ET_IGNORE, FP_CELL);

	RegisterHookChain(RG_CSGameRules_RestartRound, "CSGameRules_RestartRound_Pre");
	Player_Spawn = RegisterHookChain(RG_CBasePlayer_Spawn, "CBasePlayer_Spawn", true);
	
	new szFileCfg[64];
	get_configsdir(szFileCfg, charsmax(szFileCfg));
	formatex(szFileCfg, charsmax(szFileCfg), "%s/vip_system.cfg", szFileCfg);
	if(file_exists(szFileCfg)) server_cmd("exec %s", szFileCfg);
}

public plugin_cfg() {
	new sFlagDef[10]; get_pcvar_string(pCvar[FLAG_DEF], sFlagDef, charsmax(sFlagDef));
	new sFlag[10]; get_pcvar_string(pCvar[FLAG], sFlag, charsmax(sFlag));
	g_Flags[FLAG_DEF] = read_flags(sFlagDef);
	g_Flags[FLAG] = read_flags(sFlag);
	g_iMenuRnd = get_pcvar_num(pCvar[VIPMENU]);
	g_iBonusRnd = get_pcvar_num(pCvar[BLOCKBONUS]);
}

public CSGameRules_RestartRound_Pre() {
	if(get_member_game(m_bCompleteReset)) g_iRound = 0;
	g_iRound++;

	new Result;
	ExecuteForward(g_fwdFunction[FWD_RESTART], Result, g_iRound);
	if(g_iRound == g_iBonusRnd) EnableHookChain(Player_Spawn);
	else if(g_iRound == 0) DisableHookChain(Player_Spawn);
}

public CBasePlayer_Spawn(const id) {
	new Result;
	ExecuteForward(g_fwdFunction[FWD_SPAWN], Result, id);
}