#include <amxmodx>
#include <engine>
#include <reapi>
#include <vip_system>

#pragma semicolon 1
enum _:cvars { THROUGH_THE_WALL, SHOW_DMG };
new pCvar[cvars], g_iSayDmg, g_iVisiblePlayer;

new const Float:g_flCoords[][] = { {0.50, 0.40}, {0.56, 0.44}, {0.60, 0.50}, {0.56, 0.56}, {0.50, 0.60}, {0.44, 0.56}, {0.40, 0.50}, {0.44, 0.44} };
new g_iSize, g_iPosition[MAX_CLIENTS+1];
new bool:g_bUseDamager[MAX_CLIENTS+1];

public plugin_init() {
	register_plugin("[ReVIP] Damager", VIP_SYSTEM_VERSION, "pUzzlik");

	pCvar[THROUGH_THE_WALL] = register_cvar("through_the_wall_on","");
	pCvar[SHOW_DMG] = register_cvar("show_dmg","");

	register_clcmd("say /damager", "ShowDamage");
	register_dictionary("vip_system.txt");

	RegisterHookChain(RG_CBasePlayer_TakeDamage, "CBasePlayer_TakeDamage", true);

	if(get_block_maps()) pause("ad");
	g_iSize = sizeof(g_flCoords);
}

public plugin_cfg() {
	g_iVisiblePlayer = get_pcvar_num(pCvar[THROUGH_THE_WALL]);
	g_iSayDmg = get_pcvar_num(pCvar[SHOW_DMG]);
}

public client_putinserver(id) {
	if(g_iSayDmg) {
		new sUserInfo[16]; get_user_info(id, "_dmg", sUserInfo, charsmax(sUserInfo));
		if(sUserInfo[0] && equal(sUserInfo, "off")) g_bUseDamager[id] = false;
		else g_bUseDamager[id] = true;
	}
}

public CBasePlayer_TakeDamage(const pevVictim, pevInflictor, pevAttacker, Float:damage, bitsDamageType) {
	if(is_valid_player(pevAttacker) && get_flag_access_def(pevAttacker)) {
		if(g_iSayDmg) {
			if(!g_bUseDamager[pevAttacker]) return;
		}

		if(pevAttacker != pevVictim && rg_is_player_can_takedamage(pevVictim, pevAttacker)) {
			if(g_iVisiblePlayer) {
				if(!ent_sees_ent(pevAttacker, pevVictim)) return;
			}

			static iPos;
			iPos = ++g_iPosition[pevAttacker];
			if(iPos == g_iSize) iPos = g_iPosition[pevAttacker] = 0;

			set_hudmessage(0, 100, 200, Float:g_flCoords[iPos][0], Float:g_flCoords[iPos][1], 0, 0.1, 2.5, 0.02, 0.02);
			show_hudmessage(pevAttacker, "%.0f", damage);
		}
		return;
	}
}

public ShowDamage(id) {
	if(!get_flag_access_def(id)) {
		client_print_color(id, 0, "%L %L", LANG_SERVER, "CHAT_TAG", LANG_SERVER, "ONLY_VIP");
		return;
	}

	if(g_iSayDmg) {
		g_bUseDamager[id] = !g_bUseDamager[id];
		if(g_bUseDamager[id]) client_cmd(id, "setinfo _dmg on");
		else client_cmd(id, "setinfo _dmg off");
		client_print_color(id, 0, "%L %L", LANG_SERVER, "CHAT_TAG", LANG_SERVER, "SHOW_DMG", LANG_SERVER, g_bUseDamager[id] ? "DMG_ON" : "DMG_OFF");
	}
	else client_print_color(id, 0, "%L %L", LANG_SERVER, "CHAT_TAG", LANG_SERVER, "SAY_DMG");
	return;
}

stock bool:ent_sees_ent(iAttacker, iVictim) {
	new Float:vAttackerOrigin[3], Float:vVictimOrigin[3];

	get_entvar(iAttacker, var_origin, vAttackerOrigin);
	get_entvar(iVictim, var_origin, vVictimOrigin);

	new Float:vReturn[3]; return trace_line(iAttacker, vAttackerOrigin, vVictimOrigin, vReturn) == iVictim;
}